Scriptname SLApproachAskForSexQuestScript extends SLApproachBaseQuestScript Conditional

Function startApproach(Actor akRef)
	maxTime = 120
	talkingActor.ForceRefTo(akRef)
	rollRapeChance(akRef)
	SLApproachAskForSexQuestScene.Start()
	parent.startApproach(akRef)
EndFunction

bool property willRape  Auto Conditional

Function rollRapeChance(Actor akRef)
	int chance
	int relationship =  akRef.GetRelationshipRank(PlayerReference.GetActorReference())
	int confidence = akRef.GetActorValue("Confidence") as Int
	int aggression = akRef.GetActorValue("Aggression") as Int
	int morality = akRef.GetActorValue("Morality") as Int
	int moralityModifier = Math.pow(3,morality) as Int
	int actorArousal = akRef.GetFactionRank(arousalFaction)

	if(relationship < 0)
		relationship = (relationship - 1) * 2
	endif
	
	int relationshipModifier = ((15 - (relationship + 4))*(15 - (relationship + 4)) / 15) as Int
	int amountAware = SLApproachMain.actorAmountAware
	if(amountAware <=0)
		Debug.Trace("SexLab Approach: Wrong amount of aware actors : " + amountAware )
		Utility.Wait(0.1)
		amountAware = 1
	endif
	chance =((confidence * confidence  *  aggression  * aggression  * 2 * relationshipModifier) / (moralityModifier * amountAware  ))  as Int
	chance = chance * actorArousal / 10 as Int

	if(!akRef.WornHasKeyword(kArmorCuirass) && !akRef.WornHasKeyword(kClothingBody))
		chance = (chance + 5) * 3
	endif

	int roll = Utility.RandomInt(0, 128)
	;debug.notification("SexLab Approach RC: " + (confidence * confidence  *  aggression  * aggression  * 2 * relationshipModifier))
	;debug.notification("SexLab Approach RC: " + (moralityModifier * amountAware))

	; debug.notification("SexLab Approach RC: " + roll + " : " + chance)
	if(roll<chance)
		willRape  = true
	else
		willRape  = false
	endif
Endfunction

Function sexRelationshipDown(Actor akRef, Actor PlayerRef, int multiplier = 1)
	int relationship = akRef.GetRelationshipRank(PlayerRef)
	int roll = Utility.RandomInt(0, 100) * multiplier

	if (relationship == 4 && roll<5)
		relationship = 3
	elseif (relationship == 3 && roll<10)
		relationship = 2
	elseif (relationship == 2 && roll<15)
		relationship = 1
	elseif (relationship == 1 && roll<25)
		relationship = 0
	elseif (relationship == 0 && roll<50)
		relationship = -1
	elseif (relationship == -1)
		relationship = -2
	endif

	akRef.SetRelationshipRank(PlayerRef,relationship)
Endfunction

Function sexRelationshipUp(Actor akRef, Actor PlayerRef)
	int relationship = akRef.GetRelationshipRank(PlayerRef)
	int roll = Utility.RandomInt(0, 100)

	if (relationship == -2 || relationship == -3 || relationship == -4)
		relationship = relationship + 1
	elseif (relationship == -1 && roll<50)
		relationship = 0
	elseif (relationship == 0 && roll<25)
		relationship = 1
	elseif (relationship == 1 && roll<15)
		relationship = 2
	elseif (relationship == 2 && roll<10)
		relationship = 3
	elseif (relationship == 3 && roll<5)
		relationship = 4
	endif

	akRef.SetRelationshipRank(PlayerRef,relationship)
Endfunction

bool Function chanceRoll(Actor akRef, Actor PlayerRef, float baseChanceMultiplier )
	int chance
	int relationship =  akRef.GetRelationshipRank(PlayerRef)
	int confidence = akRef.GetActorValue("Confidence") as Int
	int aggression = akRef.GetActorValue("Aggression") as Int
	int roll
	int attraction = 100 ; SLAttractionMain.GetActorAttraction(akRef)
	int actorArousal = akRef.GetFactionRank(arousalFaction)
	if(!akRef.WornHasKeyword(kArmorCuirass) && !akRef.WornHasKeyword(kClothingBody))
		actorArousal = actorArousal + 20
		attraction = attraction + 20
	endif
	int attractionModifier = attraction ; ((attraction * attraction) / 100) as int
	int arousalModifier = actorArousal ; ((actorArousal * actorArousal ) / 100) as int
	int relationshipModifier = (relationship/2) + 7 ; ((relationship +5)*(relationship +5))/9
	chance = ((attractionModifier * arousalModifier * relationshipModifier * (6 + confidence) * (0.5 + aggression)) * baseChanceMultiplier / 550) as Int
	; debug.notification("Ask for sex chance: " + chance)
	; debug.notification("Ask for sex bCM: " + baseChanceMultiplier)
	roll = Utility.RandomInt(0, 10000)

	if(roll<chance)
		return true
	endif
	return false
endfunction

Function register()
	index = -1
	while(index == -1)
		Utility.Wait(1.0)
		 index = SLApproachMain.RegisterQuest(ApproachQuest, self, "Ask for sex", 1)
	endwhile
EndFunction

Function endApproach()
	approachEnding = true
	SLApproachAskForSexQuestScene.Stop()
	SLApproachAskForSexQuestFollowPlayerScene.Stop()
	parent.endApproach()
Endfunction

ReferenceAlias Property talkingActor  Auto  


Scene Property SLApproachAskForSexQuestScene  Auto  
Scene Property SLApproachAskForSexQuestFollowPlayerScene Auto
ReferenceAlias Property PlayerReference Auto
;SLAttractionMainScript Property SLAttractionMain  Auto
Faction Property ArousalFaction  Auto
Keyword Property kArmorCuirass Auto
Keyword Property kClothingBody Auto