Scriptname SLApproachConfigScript extends SKI_ConfigBase  

int cloakFrequencyOID
int cloakRangeOID 
int baseChanceMultiplierOID 
int totalAwarnessRangeOID

SLApproachMainScript Property SLApproachMain Auto

event OnPageReset(string page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetCursorPosition(2)

	AddHeaderOption("General: ")
       cloakFrequencyOID =  AddSliderOption("Cloak frequency:", SLApproachMain.cloakFrequency,"once per {0} seconds")
	cloakRangeOID =  AddSliderOption("Cloak range:", SLApproachMain.cloakRange)
	baseChanceMultiplierOID =  AddSliderOption("Base approach chance multiplier:", SLApproachMain.baseChanceMultiplier, "{1}")
	totalAwarnessRangeOID = AddSliderOption("Total awarness range:", SLApproachMain.totalAwarnessRange)
	AddEmptyOption()

	AddHeaderOption("Registered approach quests: ")
	int indexCounter = SLApproachMain.getRegisteredAmount()
			
	while(indexCounter > 0)
		indexCounter = indexCounter - 1
		AddToggleOption(SLApproachMain.getApproachQuestName(indexCounter),true)
	endwhile
	
endevent

event OnOptionSliderOpen(int option)
	if (option == cloakFrequencyOID)
		SetSliderDialogStartValue( SLApproachMain.cloakFrequency)
		SetSliderDialogDefaultValue( SLApproachMain.cloakFrequency)
		SetSliderDialogRange(1.0, 120.0)
		SetSliderDialogInterval(1.0)
	elseif (option == cloakRangeOID )
		SetSliderDialogStartValue( SLApproachMain.cloakRange)
		SetSliderDialogDefaultValue( SLApproachMain.cloakRange)
		SetSliderDialogRange(64.0, 256.0)
		SetSliderDialogInterval(1.0)
	elseif (option == baseChanceMultiplierOID )
		SetSliderDialogStartValue( SLApproachMain.baseChanceMultiplier)
		SetSliderDialogDefaultValue( SLApproachMain.baseChanceMultiplier)
		SetSliderDialogRange(0.0, 10.0)
		SetSliderDialogInterval(0.1)
	elseif (option == totalAwarnessRangeOID )
		SetSliderDialogStartValue( SLApproachMain.totalAwarnessRange)
		SetSliderDialogDefaultValue( SLApproachMain.totalAwarnessRange)
		SetSliderDialogRange(0, 1024.0)
		SetSliderDialogInterval(1.0)
	endif
endevent

event OnOptionSliderAccept(int option, float value)
	if (option == cloakFrequencyOID)
		SLApproachMain.cloakFrequency= value as Int
		SetSliderOptionValue(cloakFrequencyOID, SLApproachMain.cloakFrequency)
	elseif (option == cloakRangeOID )
		SLApproachMain.cloakRange= value as Int
		SetSliderOptionValue(cloakRangeOID , SLApproachMain.cloakRange)
	elseif (option == baseChanceMultiplierOID )
		SLApproachMain.baseChanceMultiplier= value
		SetSliderOptionValue(baseChanceMultiplierOID , SLApproachMain.baseChanceMultiplier, "{1}")
	elseif (option == totalAwarnessRangeOID )
		SLApproachMain.totalAwarnessRange= value as Int
		SetSliderOptionValue(totalAwarnessRangeOID , SLApproachMain.totalAwarnessRange)
	endif
endevent